## sdl12-compat 1.2.64

=== CMakeLists.txt ===
# NOTE:  If you installed SDL2 at an unusual place and FindSDL2 fails,
#        you can define SDL2_INCLUDE_DIR on the cmdline.  For example:
#        cmake -DSDL2_INCLUDE_DIR=/opt/SDL2/include/SDL2 [other stuff]

cmake_minimum_required(VERSION 3.0.0)
project(sdl12_compat
        VERSION 1.2.64
        LANGUAGES C)

option(SDL12TESTS "Enable to build SDL-1.2 test programs" ON)
option(SDL12DEVEL "Enable installing SDL-1.2 development headers" ON)
option(STATICDEVEL "Enable installing static link library" OFF)

if(STATICDEVEL AND NOT (CMAKE_SYSTEM_NAME MATCHES "Linux"))
  message(FATAL_ERROR "Static builds are only supported on Linux.")
endif()

list(APPEND CMAKE_MODULE_PATH
    "${CMAKE_CURRENT_LIST_DIR}/cmake/modules"
)

include(CheckCSourceCompiles)
include(CheckIncludeFile)
include(CheckCCompilerFlag)
include(GNUInstallDirs)

set(CMAKE_SKIP_RPATH TRUE)

if(APPLE)
  set(OSX_SRCS "src/SDL12_compat_objc.m")
  set_source_files_properties(${OSX_SRCS} PROPERTIES LANGUAGE C)
  # compatibility version set to match SDL-1.2 autotools build
  # Xcode project file uses 1.0.0, but it's more compatible to use the
  # higher version.
  set(DYLIB_COMPAT_VERSION 12.0.0 CACHE STRING "library compatibility version")
  set(DYLIB_CURRENT_VERSION 12.64.0 CACHE STRING "library current version")
  include_directories("/opt/X11/include")  # hack.
  if(CMAKE_VERSION VERSION_LESS 3.9)
  else()
    cmake_policy(SET CMP0068 NEW)  # on macOS, don't let RPATH affect install_name.
  endif()
endif()

if(WIN32)
  set(WIN32_SRCS "src/version.rc")
endif()

set(SDL12COMPAT_SRCS
  src/SDL12_compat.c
  ${OSX_SRCS}
  ${WIN32_SRCS}
)
add_library(SDL SHARED ${SDL12COMPAT_SRCS})

find_package(SDL2)
if(NOT SDL2_INCLUDE_DIRS)
  message(FATAL_ERROR "Could not find SDL2 headers")
endif()
target_include_directories(SDL PRIVATE ${SDL2_INCLUDE_DIRS})

set(EXTRA_CFLAGS )
if (CMAKE_C_COMPILER_ID MATCHES "Clang|GNU")
  set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -Wall")
  check_c_compiler_flag(-Wdeclaration-after-statement HAVE_WDECLARATION_AFTER_STATEMENT)
  if(HAVE_WDECLARATION_AFTER_STATEMENT)
    set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -Wdeclaration-after-statement")
  endif()
  check_c_compiler_flag(-Werror=declaration-after-statement HAVE_WERROR_DECLARATION_AFTER_STATEMENT)
  if(HAVE_WERROR_DECLARATION_AFTER_STATEMENT)
    set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -Werror=declaration-after-statement")
  endif()
endif()
# just in case:
check_include_file("immintrin.h" HAVE_IMMINTRIN_H)
if(NOT HAVE_IMMINTRIN_H)
  set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -DSDL_DISABLE_IMMINTRIN_H")
endif()
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_CFLAGS}")
string(STRIP "${CMAKE_C_FLAGS}" CMAKE_C_FLAGS)

if(UNIX AND NOT APPLE)
    set_target_properties(SDL PROPERTIES COMPILE_DEFINITIONS "_REENTRANT")
    target_link_libraries(SDL PRIVATE ${CMAKE_DL_LIBS})
endif()
if(APPLE)
    set_target_properties(SDL PROPERTIES COMPILE_DEFINITIONS "_THREAD_SAFE")
    set_target_properties(SDL PROPERTIES LINK_FLAGS
            "-Wl,-compatibility_version,${DYLIB_COMPAT_VERSION} -Wl,-current_version,${DYLIB_CURRENT_VERSION}")
    target_link_libraries(SDL PRIVATE "-framework AppKit")
    set_target_properties(SDL PROPERTIES
        OUTPUT_NAME "SDL-1.2.0"
    )
elseif(UNIX AND NOT ANDROID)
    set_target_properties(SDL PROPERTIES
        VERSION "${PROJECT_VERSION}"
        SOVERSION "0"
        OUTPUT_NAME "SDL-1.2")
elseif(WIN32)
    # avoid DLL having 'lib' prefix with MinGW
    set(CMAKE_SHARED_LIBRARY_PREFIX "")
    set_target_properties(SDL PROPERTIES COMPILE_DEFINITIONS "DLL_EXPORT")
    set_target_properties(SDL PROPERTIES
        VERSION "${PROJECT_VERSION}"
        SOVERSION "0"
        OUTPUT_NAME "SDL")
elseif(OS2)
    set_target_properties(SDL PROPERTIES COMPILE_DEFINITIONS "BUILD_SDL") # for DECLSPEC
    set_target_properties(SDL PROPERTIES
        VERSION "${PROJECT_VERSION}"
        SOVERSION "0"
        OUTPUT_NAME "SDL12")
else()
    set_target_properties(SDL PROPERTIES
        VERSION "${PROJECT_VERSION}"
        SOVERSION "0"
        OUTPUT_NAME "SDL")
endif()

if(MINGW)
    set_target_properties(SDL PROPERTIES LINK_FLAGS "-nostdlib")
    target_link_libraries(SDL PRIVATE "-static-libgcc -lgcc") # libgcc is needed for 32 bit (x86) builds
endif()
if(MSVC)
    # Don't try to link with the default set of libraries.
    set(MSVC_FLAGS "/GS-")
    check_c_source_compiles("int main(void) {
#ifndef _M_IX86
#error not x86
#endif
return 0; }" IS_X86)
    if(IS_X86)  # don't emit SSE2 in x86 builds
      set(MSVC_FLAGS "${MSVC_FLAGS} /arch:SSE")
    endif()
    set_target_properties(SDL PROPERTIES COMPILE_FLAGS ${MSVC_FLAGS})
    set_target_properties(SDL PROPERTIES LINK_FLAGS "/NODEFAULTLIB")
    # Make sure /RTC1 is disabled: (from SDL2 CMake)
    foreach(flag_var
      CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
      CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      string(REGEX REPLACE "/RTC(su|[1su])" "" ${flag_var} "${${flag_var}}")
    endforeach(flag_var)
endif()

# SDLmain library...
if(APPLE)
    add_library(SDLmain STATIC src/SDLmain/macosx/SDLMain.m)
    set_source_files_properties(src/SDLmain/macosx/SDLMain.m PROPERTIES LANGUAGE C)
elseif(WIN32)
    add_library(SDLmain STATIC src/SDLmain/win32/SDL_win32_main.c)
    set_target_properties(SDLmain PROPERTIES COMPILE_DEFINITIONS "_CRT_SECURE_NO_WARNINGS;_CRT_SECURE_NO_DEPRECATE;_CRT_NONSTDC_NO_DEPRECATE")  # !!! FIXME: don't use C runtime? We fixed this in SDL2.
else()
    add_library(SDLmain STATIC src/SDLmain/dummy/SDL_dummy_main.c)
endif()
target_include_directories(SDLmain PRIVATE "include/SDL")

if(SDL12TESTS)
    if(NOT (WIN32 OR APPLE OR CYGWIN OR HAIKU OR BEOS))
      find_library(MATH_LIBRARY m)
    endif()

    find_package(OpenGL COMPONENTS OpenGL)
    if(OPENGL_FOUND)
      set(HAVE_OPENGL_DEFINE "HAVE_OPENGL")
      if(WIN32)
        set(OPENGL_gl_LIBRARY "opengl32")
        set(OPENGL_opengl_LIBRARY "opengl32")
      elseif(APPLE)
        set(OPENGL_gl_LIBRARY "-Wl,-framework,OpenGL")
        set(OPENGL_opengl_LIBRARY "-Wl,-framework,OpenGL")
      endif()
    endif()

    macro(test_program _NAME _SRCS)
        add_executable(${_NAME} ${_SRCS})
        target_include_directories(${_NAME} PRIVATE "include/SDL")
        if(MINGW)
          target_link_libraries(${_NAME} mingw32 SDLmain SDL)
        else()
          target_link_libraries(${_NAME} SDLmain SDL)
        endif()
        # Turn off MSVC's aggressive C runtime warnings for the old test programs.
        if(MSVC)
          set_target_properties(${_NAME} PROPERTIES COMPILE_DEFINITIONS "${HAVE_OPENGL_DEFINE};_CRT_SECURE_NO_WARNINGS;_CRT_SECURE_NO_DEPRECATE;_CRT_NONSTDC_NO_DEPRECATE")
        elseif(APPLE)
          set_target_properties(${_NAME} PROPERTIES COMPILE_DEFINITIONS "${HAVE_OPENGL_DEFINE};GL_SILENCE_DEPRECATION=1")
          target_link_libraries(${_NAME} "-Wl,-framework,Cocoa")
        else()
          set_target_properties(${_NAME} PROPERTIES COMPILE_DEFINITIONS "${HAVE_OPENGL_DEFINE}")
        endif()
        if(MATH_LIBRARY)
          target_link_libraries(${_NAME} ${MATH_LIBRARY})
        endif()
    endmacro()

    test_program(checkkeys "test/checkkeys.c")
    test_program(graywin "test/graywin.c")
    test_program(loopwave "test/loopwave.c")
    test_program(testalpha "test/testalpha.c")
    test_program(testbitmap "test/testbitmap.c")
    test_program(testblitspeed "test/testblitspeed.c")
    test_program(testcdrom "test/testcdrom.c")
    test_program(testcursor "test/testcursor.c")
    test_program(testerror "test/testerror.c")
    test_program(testfile "test/testfile.c")
    test_program(testgamma "test/testgamma.c")
    test_program(testthread "test/testthread.c")
    test_program(testiconv "test/testiconv.c")
    test_program(testjoystick "test/testjoystick.c")
    test_program(testkeys "test/testkeys.c")
    test_program(testloadso "test/testloadso.c")
    test_program(testlock "test/testlock.c")
    test_program(testoverlay "test/testoverlay.c")
    test_program(testoverlay2 "test/testoverlay2.c")
    test_program(testpalette "test/testpalette.c")
    test_program(testplatform "test/testplatform.c")
    test_program(testsem "test/testsem.c")
    test_program(testsprite "test/testsprite.c")
    test_program(testtimer "test/testtimer.c")
    test_program(testver "test/testver.c")
    test_program(testvidinfo "test/testvidinfo.c")
    test_program(testwin "test/testwin.c")
    test_program(testwm "test/testwm.c")
    test_program(threadwin "test/threadwin.c")
    test_program(torturethread "test/torturethread.c")
    test_program(testdyngl "test/testdyngl.c")
    test_program(testgl "test/testgl.c")
    if(OPENGL_FOUND)
      if(CMAKE_VERSION VERSION_LESS 3.10 OR NOT OPENGL_opengl_LIBRARY)
        target_link_libraries(testgl ${OPENGL_gl_LIBRARY})
      else()
        target_link_libraries(testgl ${OPENGL_opengl_LIBRARY})
      endif()
    endif()

    foreach(fname "icon.bmp" "moose.dat" "picture.xbm" "sail.bmp" "sample.bmp" "sample.wav" "utf8.txt")
        file(COPY "${CMAKE_SOURCE_DIR}/test/${fname}" DESTINATION "${CMAKE_BINARY_DIR}")
    endforeach(fname)
endif()

install(TARGETS SDL SDLmain
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

if(SDL12DEVEL)
  install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

  if(NOT MSVC)
    if(WIN32)
      set(SDL_CFLAGS "")
      set(SDL_RLD_FLAGS "")
      set(SDL_LIBS "-lmingw32 -lSDLmain -lSDL -mwindows")
      set(SDL_STATIC_LIBS "")
    elseif(APPLE)
      set(SDL_CFLAGS "-D_THREAD_SAFE")
      set(SDL_LIBS "-lSDLmain -lSDL -Wl,-framework,Cocoa")
      set(SDL_STATIC_LIBS "")
      set(SDL_RLD_FLAGS "")  # !!! FIXME: this forces rpath, which we might want?
    else() # unix
      set(SDL_CFLAGS "-D_GNU_SOURCE=1 -D_REENTRANT")
      set(SDL_RLD_FLAGS "")  # !!! FIXME: this forces rpath, which we might want?
      set(SDL_LIBS "-lSDL")
      set(SDL_STATIC_LIBS "")
      foreach(lib ${CMAKE_DL_LIBS})
          set(SDL_STATIC_LIBS "-l${lib}")
      endforeach()
      if(NOT STATICDEVEL)
        set(SDL_STATIC_LIBS "")
      endif()
    endif()

    # !!! FIXME: do we _want_ static builds?
    if(STATICDEVEL)
      set(ENABLE_STATIC_TRUE "")
      set(ENABLE_STATIC_FALSE "#")
    else()
      set(ENABLE_STATIC_TRUE "#")
      set(ENABLE_STATIC_FALSE "")
    endif()
    set(ENABLE_SHARED_TRUE "")
    set(ENABLE_SHARED_FALSE "#")

    configure_file(sdl12_compat.pc.in sdl12_compat.pc @ONLY)
    install(FILES ${CMAKE_BINARY_DIR}/sdl12_compat.pc
      DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    )

    configure_file("${CMAKE_SOURCE_DIR}/sdl-config.in" "${CMAKE_BINARY_DIR}/sdl-config" @ONLY)
    install(PROGRAMS "${CMAKE_BINARY_DIR}/sdl-config" DESTINATION bin)
  endif()

  set(SOEXT ${CMAKE_SHARED_LIBRARY_SUFFIX})
  get_target_property(SONAME SDL OUTPUT_NAME)
  if(UNIX AND NOT ANDROID)
    install(CODE "
      execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink
        \"lib${SONAME}${SOPOSTFIX}${SOEXT}\" \"libSDL${SOPOSTFIX}${SOEXT}\"
        WORKING_DIRECTORY \"${CMAKE_BINARY_DIR}\")")
    install(FILES ${CMAKE_BINARY_DIR}/libSDL${SOPOSTFIX}${SOEXT} DESTINATION "${CMAKE_INSTALL_LIBDIR}")
  endif()

  install(FILES "${CMAKE_SOURCE_DIR}/sdl.m4" DESTINATION "${CMAKE_INSTALL_FULL_DATAROOTDIR}/aclocal")
endif()

if(STATICDEVEL AND SDL12DEVEL)
  add_library(SDL-static STATIC ${SDL12COMPAT_SRCS})
  target_include_directories(SDL-static PRIVATE ${SDL2_INCLUDE_DIRS})
  set_target_properties(SDL-static PROPERTIES COMPILE_DEFINITIONS "_REENTRANT")
  target_link_libraries(SDL-static PRIVATE ${CMAKE_DL_LIBS})
  set_target_properties(SDL-static PROPERTIES
          VERSION "${PROJECT_VERSION}"
        OUTPUT_NAME "SDL")

  install(TARGETS SDL-static
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
endif()

=== debian/changelog ===
sdl12-compat (1.2.64-5) unstable; urgency=medium

  * Release to unstable (transition: #1039911)
    - The source package doesn't contain X11 extensions (Closes: #465780)
    - libsdl1.2debian no longer links to the GPL libcaca library
      (Closes: #871807)
    - This version of SDL_opengl.h no longer includes glext.h
      (Closes: #925324)
    - This finally makes libsdl1.2-dev multiarch co-installable
      (Closes: #932372)

 -- Simon McVittie <smcv@debian.org>  Tue, 11 Jul 2023 21:43:08 +0100

sdl12-compat (1.2.64-4+exp1) experimental; urgency=medium

  * Take over libsdl1.2debian, libsdl1.2-dev from SDL 1.2 classic.
    This makes sdl12-compat into Debian's default implementation of
    the SDL 1.2 API and ABI. libsdl1.2-compat{,-shim,-dev} become
    transitional packages; for full compatibility with the way
    libsdl1.2-compat used to work, it still contains symlinks in
    /usr/lib/*/sdl12-compat, which can be LD_PRELOADed or prepended to the
    LD_LIBRARY_PATH.
  * Upload to experimental until we're ready to do this transition

 -- Simon McVittie <smcv@debian.org>  Thu, 29 Jun 2023 12:28:24 +0100

sdl12-compat (1.2.64-4) unstable; urgency=medium

  * Add patches from upstream for better bug-for-bug compatibility with
    recompiling SDL 1.2 code
    - d/p/SDL_config.h-Assume-that-all-platforms-have-ISO-C89-stdde.patch:
      Always include <stddef.h>, which berusky assumes we will do
      (mitigates: #1039439)
    - d/p/include-Use-struct-private_hwdata-incomplete-type-for-API.patch:
      Use the same naming for a private struct member that asc assumes we
      will do (mitigates: #1039574)
    - d/p/SDL_config-Define-HAVE_MALLOC_H-on-glibc-based-platforms.patch:
      Define HAVE_MALLOC_H, which freespace2 assumes we will do
      (mitigates: #1012232)
  * d/p/debian/sdl-config-Remove-libdir-for-multiarch-co-installability.patch:
    Move to debian subdirectory to distinguish this non-upstreamable patch

 -- Simon McVittie <smcv@debian.org>  Thu, 29 Jun 2023 10:55:32 +0100

sdl12-compat (1.2.64-3) unstable; urgency=medium

  * d/control: libsdl1.2-compat-dev depends on GL, GLU headers.
    <SDL/SDL_opengl.h> depends on these, and some SDL-dependent packages
    like achilles and antigrav have also traditionally assumed that the
    SDL -dev package would arrange for GL headers to be provided.
    (Mitigates: #1039072)
  * d/control: libsdl1.2-compat-dev Depends on pkgconf.
    This is a workaround for packages that assumed that a dependency
    on libsdl1.2-dev would pull in pkg-config and therefore provide the
    pkg.m4 macros, such as adplay.
    (Mitigates: #1039074)
  * d/control: Make libsdl1.2-compat-dev depend on libsdl2-dev.
    This is not actually a real dependency, but it's an easy way to pull
    in a lot of the packages that libsdl1.2-dev traditionally depended
    on without having to list them explicitly, making it less likely
    that dependent packages will FTBFS with libsdl1.2-compat-dev.

 -- Simon McVittie <smcv@debian.org>  Mon, 26 Jun 2023 11:09:53 +0100

sdl12-compat (1.2.64-2) unstable; urgency=medium

  * Release to unstable

 -- Simon McVittie <smcv@debian.org>  Mon, 12 Jun 2023 14:23:44 +0100

sdl12-compat (1.2.64-1) experimental; urgency=medium

  * New upstream release
    - Compatibility with: Steel Storm Burning Retribution
      (based on an older darkplaces engine)

 -- Simon McVittie <smcv@debian.org>  Thu, 01 Jun 2023 10:34:32 +0100

sdl12-compat (1.2.62-1) experimental; urgency=medium

  * New upstream prerelease
    - Compatibility with: Alpha Centauri, tuxfootball, xrick
    - Quirk workarounds for: freedroid, grafx2
  * d/patches: Drop most patches, included upstream
  * d/copyright: Update

 -- Simon McVittie <smcv@debian.org>  Thu, 18 May 2023 17:29:51 +0100

sdl12-compat (1.2.60-2) experimental; urgency=medium

  * d/patches: Add post-release bug fixes from upstream.
    This fixes compatibility with boswars, fillets-ng and pink-pony.

 -- Simon McVittie <smcv@debian.org>  Wed, 30 Nov 2022 15:28:25 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

# used in dh_install, dh_link
export DEB_VERSION_UPSTREAM

%:
	dh $@ -Scmake

# debhelper >= 13.4 makes all of /usr/libexec executable, which is not
# quite right for installed-tests (#1006927)
override_dh_fixperms:
	dh_fixperms -Xusr/libexec/installed-tests
	chmod --recursive a+rX,u+w,og-w debian/*-tests/usr/libexec/installed-tests

override_dh_gencontrol:
	dh_gencontrol -- -Vsdl12compat:Takeover-Version=1.2.64-4+exp1

## sdl12-compat 1.2.68

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,9 @@
 #        you can define SDL2_INCLUDE_DIR on the cmdline.  For example:
 #        cmake -DSDL2_INCLUDE_DIR=/opt/SDL2/include/SDL2 [other stuff]
 
-cmake_minimum_required(VERSION 3.0.0)
+cmake_minimum_required(VERSION 3.0.0...3.5)
 project(sdl12_compat
-        VERSION 1.2.64
+        VERSION 1.2.68
         LANGUAGES C)
 
 option(SDL12TESTS "Enable to build SDL-1.2 test programs" ON)
@@ -16,7 +16,7 @@
 endif()
 
 list(APPEND CMAKE_MODULE_PATH
-    "${CMAKE_CURRENT_LIST_DIR}/cmake/modules"
+  "${CMAKE_CURRENT_LIST_DIR}/cmake/modules"
 )
 
 include(CheckCSourceCompiles)
@@ -33,7 +33,7 @@
   # Xcode project file uses 1.0.0, but it's more compatible to use the
   # higher version.
   set(DYLIB_COMPAT_VERSION 12.0.0 CACHE STRING "library compatibility version")
-  set(DYLIB_CURRENT_VERSION 12.64.0 CACHE STRING "library current version")
+  set(DYLIB_CURRENT_VERSION 12.68.0 CACHE STRING "library current version")
   include_directories("/opt/X11/include")  # hack.
   if(CMAKE_VERSION VERSION_LESS 3.9)
   else()

=== debian/changelog ===
sdl12-compat (1.2.68-2) unstable; urgency=medium

  * d/p/sdl.m4-Call-PKG_CONFIG-rather-than-hard-coding-pkg-config.patch:
    Add patch from upstream git to fix cross-compilation of ltris and
    possibly others. Thanks to Helmut Grohne (Closes: #1059749)

 -- Simon McVittie <smcv@debian.org>  Tue, 02 Jan 2024 15:09:33 +0000

sdl12-compat (1.2.68-1) unstable; urgency=medium

  * New upstream stable release
    - Functionally equivalent to 1.2.66

 -- Simon McVittie <smcv@debian.org>  Tue, 26 Sep 2023 19:57:49 +0100

sdl12-compat (1.2.66-1) unstable; urgency=medium

  * New upstream prerelease (1.2.68 rc1)
    - Avoid reporting unscaled mouse coordinates, fixing mouse offset in
      Sid Meier's Alpha Centauri
    - Make it possible to limit bits-per-pixel to a value from a hint/quirk
    - Quirk workaround for: Hyperspace Delivery Boy
  * d/gbp.conf: Back to the debian/latest branch

 -- Simon McVittie <smcv@debian.org>  Fri, 15 Sep 2023 09:27:02 +0100

sdl12-compat (1.2.64+git20230904+g9359cfa-1) experimental; urgency=medium

  * New upstream git snapshot
    - Improve compatibility with games that incorrectly try to free the
      video surface (Closes: #1041416)
    - Add a hint/quirk for forcing XInitThreads to be called
    - Add quirks table entries for Mark of the Ninja (Closes: #1051106)
      and Trine
    - Fix return value of SDL_SetPalette(): 0 on error, 1 on success
    - Fix a crash if SDL_LoadWAV() fails to open the file
    - Improve compile-time robustness with newer SDL2
    - Update included copy of dr_mp3 (no functional changes)
    - macOS- and OS/2-specific changes not relevant to Debian
  * d/p/SDL_config.h-Assume-that-all-platforms-have-ISO-C89-stdde.patch,
    d/p/include-Use-struct-private_hwdata-incomplete-type-for-API.patch,
    d/p/SDL_config-Define-HAVE_MALLOC_H-on-glibc-based-platforms.patch:
    Drop patches, applied upstream
  * d/gbp.conf, d/watch.git-snapshots: Configure for git snapshots

 -- Simon McVittie <smcv@debian.org>  Tue, 12 Sep 2023 16:06:09 +0100

=== debian/control ===
Source: sdl12-compat
Priority: optional
Maintainer: Debian SDL package maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
Uploaders:
 Simon McVittie <smcv@debian.org>,
 Stephen Kitt <skitt@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libglu1-mesa-dev,
 libsdl2-dev,
 libx11-dev,
Standards-Version: 4.6.2
Section: libs
Homepage: https://github.com/libsdl-org/sdl12-compat
Vcs-Git: https://salsa.debian.org/sdl-team/sdl12-compat.git
Vcs-Browser: https://salsa.debian.org/sdl-team/sdl12-compat
Rules-Requires-Root: no

Package: libsdl1.2-compat
Section: oldlibs
Architecture: any
Multi-Arch: same
Depends:
 libsdl1.2debian (>= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: SDL 1.2 binary compatibility library - transitional package
 sdl12-compat provides a binary compatible API for programs built
 against SDL 1.2, but using SDL 2.0.
 .
 If you are writing new code, please target SDL 2.0 directly instead
 of using this layer.
 .
 This transitional package provides symbolic links to the library in a private
 location, matching the way it was used before it was Debian's default
 implementation of the SDL 1.2 ABI.

Package: libsdl1.2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libgl-dev,
 libglu1-mesa-dev,
 libsdl1.2debian (= ${binary:Version}),
 libsdl2-dev,
 pkgconf,
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Provides:
 libsdl-dev (= ${binary:Version}),
 libsdl1.2-compat-dev (= ${binary:Version}),
Breaks:
 libsdl-dev (<< ${sdl12compat:Takeover-Version}~),
 libsdl1.2-compat-dev (<< ${sdl12compat:Takeover-Version}~),
Replaces:
 libsdl-dev (<< ${sdl12compat:Takeover-Version}~),
 libsdl1.2-compat-dev (<< ${sdl12compat:Takeover-Version}~),
Description: SDL 1.2 binary compatibility library - development files
 sdl12-compat provides a binary compatible API for programs built
 against SDL 1.2, but using SDL 2.0.
 .
 If you are writing new code, please target SDL 2.0 directly instead
 of using this layer.
 .
 This package provides development files.

Package: libsdl1.2debian
Architecture: any
Multi-Arch: same
Depends:
 libsdl2-2.0-0,
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Provides:
 libsdl-1.2-0 (= ${binary:Version}),
 libsdl1.2-compat-shim (= ${binary:Version}),
Breaks:
 libsdl1.2-compat (<< ${sdl12compat:Takeover-Version}~),
 libsdl1.2-compat-shim (<< ${sdl12compat:Takeover-Version}~),
Replaces:
 libsdl1.2-compat (<< ${sdl12compat:Takeover-Version}~),
 libsdl1.2-compat-shim (<< ${sdl12compat:Takeover-Version}~),
Description: SDL 1.2 binary compatibility library wrapping SDL 2.0
 This package contains sdl12-compat, a binary compatible API for programs built
 against SDL 1.2, but using SDL 2.0.
 .
 This package replaces the classic SDL 1.2 library with the SDL 2.0
 compatibility layer, so that all SDL 1.2 program will use it.
 .
 If you are writing new code, please target SDL 2.0 directly instead
 of using this layer.

Package: libsdl1.2-compat-dev
Section: oldlibs
Architecture: any
Multi-Arch: same
Depends:
 libsdl1.2-dev (>= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: SDL 1.2 binary compatibility library - transitional development files
 sdl12-compat provides a binary compatible API for programs built
 against SDL 1.2, but using SDL 2.0.
 .
 If you are writing new code, please target SDL 2.0 directly instead
 of using this layer.
 .
 This transitional package depends on a version of libsdl1.2-dev
 new enough that it actually contains sdl12-compat development files.

Package: libsdl1.2-compat-shim
Section: oldlibs
Architecture: any
Multi-Arch: same
Depends:
 libsdl1.2debian (>= ${binary:Version}),
 libsdl1.2-compat (>= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: libsdl1.2debian replacement using SDL 2.0 - transitional package
 sdl12-compat provides a binary compatible API for programs built
 against SDL 1.2, but using SDL 2.0.
 .
 If you are writing new code, please target SDL 2.0 directly instead
 of using this layer.
 .
 This transitional package depends on a version of libsdl1.2debian
 new enough that it actually contains sdl12-compat.

Package: libsdl1.2-compat-tests
Section: misc
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: SDL 1.2 binary compatibility library - tests
 libsdl1.2-compat provides a binary compatible API for programs built
 against SDL 1.2, but using SDL 2.0.
 .
 If you are writing new code, please target SDL 2.0 directly instead
 of using this layer.
 .
 This package provides manual test programs.

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 include /usr/share/dpkg/default.mk
 
 # used in dh_install, dh_link
-export DEB_VERSION_UPSTREAM
+export ABI_VERSION=$(DEB_VERSION_UPSTREAM)
 
 %:
 	dh $@ -Scmake

=== debian/watch ===
version=4
opts="\
    compression=gzip, \
    dversionmangle=s/\+(?:git)?[0-9]*(?:\+g[0-9a-f]*)//, \
    downloadurlmangle=s#/releases/tag/#/archive/refs/tags/#;s#((?:pre)?release-?@ANY_VERSION@)$#$1/@PACKAGE@-$2.tar.gz#, \
    filenamemangle=s#(?:pre)?release-?@ANY_VERSION@#@PACKAGE@-$1.tar.gz#" \
https://github.com/libsdl-org/@PACKAGE@/tags .*/releases/tag/release-?@ANY_VERSION@

# or:
#opts="mode=git" \
#https://github.com/libsdl-org/@PACKAGE@ \
#refs/tags/release-@ANY_VERSION@

## sdl12-compat 1.2.69~git20250930~6152f8d

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,9 @@
 #        you can define SDL2_INCLUDE_DIR on the cmdline.  For example:
 #        cmake -DSDL2_INCLUDE_DIR=/opt/SDL2/include/SDL2 [other stuff]
 
-cmake_minimum_required(VERSION 3.0.0...3.5)
+cmake_minimum_required(VERSION 3.0.0...4.0)
 project(sdl12_compat
-        VERSION 1.2.68
+        VERSION 1.2.69
         LANGUAGES C)
 
 option(SDL12TESTS "Enable to build SDL-1.2 test programs" ON)
@@ -29,11 +29,15 @@
 if(APPLE)
   set(OSX_SRCS "src/SDL12_compat_objc.m")
   set_source_files_properties(${OSX_SRCS} PROPERTIES LANGUAGE C)
+  if(NOT CMAKE_VERSION VERSION_LESS "3.16")
+      enable_language(OBJC)
+      set_source_files_properties(${OSX_SRCS} PROPERTIES LANGUAGE OBJC)
+  endif()
   # compatibility version set to match SDL-1.2 autotools build
   # Xcode project file uses 1.0.0, but it's more compatible to use the
   # higher version.
   set(DYLIB_COMPAT_VERSION 12.0.0 CACHE STRING "library compatibility version")
-  set(DYLIB_CURRENT_VERSION 12.68.0 CACHE STRING "library current version")
+  set(DYLIB_CURRENT_VERSION 12.69.0 CACHE STRING "library current version")
   include_directories("/opt/X11/include")  # hack.
   if(CMAKE_VERSION VERSION_LESS 3.9)
   else()
@@ -145,6 +149,9 @@
 if(APPLE)
     add_library(SDLmain STATIC src/SDLmain/macosx/SDLMain.m)
     set_source_files_properties(src/SDLmain/macosx/SDLMain.m PROPERTIES LANGUAGE C)
+    if(NOT CMAKE_VERSION VERSION_LESS "3.16")
+        set_source_files_properties("src/SDLmain/macosx/SDLMain.m" PROPERTIES LANGUAGE OBJC)
+    endif()
 elseif(WIN32)
     add_library(SDLmain STATIC src/SDLmain/win32/SDL_win32_main.c)
     set_target_properties(SDLmain PROPERTIES COMPILE_DEFINITIONS "_CRT_SECURE_NO_WARNINGS;_CRT_SECURE_NO_DEPRECATE;_CRT_NONSTDC_NO_DEPRECATE")  # !!! FIXME: don't use C runtime? We fixed this in SDL2.
@@ -233,7 +240,7 @@
     endif()
 
     foreach(fname "icon.bmp" "moose.dat" "picture.xbm" "sail.bmp" "sample.bmp" "sample.wav" "utf8.txt")
-        file(COPY "${CMAKE_SOURCE_DIR}/test/${fname}" DESTINATION "${CMAKE_BINARY_DIR}")
+        file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/test/${fname}" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
     endforeach(fname)
 endif()
 
@@ -282,12 +289,12 @@
     set(ENABLE_SHARED_FALSE "#")
 
     configure_file(sdl12_compat.pc.in sdl12_compat.pc @ONLY)
-    install(FILES ${CMAKE_BINARY_DIR}/sdl12_compat.pc
+    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/sdl12_compat.pc
       DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
     )
 
-    configure_file("${CMAKE_SOURCE_DIR}/sdl-config.in" "${CMAKE_BINARY_DIR}/sdl-config" @ONLY)
-    install(PROGRAMS "${CMAKE_BINARY_DIR}/sdl-config" DESTINATION bin)
+    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/sdl-config.in" "${CMAKE_CURRENT_BINARY_DIR}/sdl-config" @ONLY)
+    install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/sdl-config" DESTINATION bin)
   endif()
 
   set(SOEXT ${CMAKE_SHARED_LIBRARY_SUFFIX})
@@ -296,23 +303,14 @@
     install(CODE "
       execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink
         \"lib${SONAME}${SOPOSTFIX}${SOEXT}\" \"libSDL${SOPOSTFIX}${SOEXT}\"
-        WORKING_DIRECTORY \"${CMAKE_BINARY_DIR}\")")
-    install(FILES ${CMAKE_BINARY_DIR}/libSDL${SOPOSTFIX}${SOEXT} DESTINATION "${CMAKE_INSTALL_LIBDIR}")
-  endif()
-
-  install(FILES "${CMAKE_SOURCE_DIR}/sdl.m4" DESTINATION "${CMAKE_INSTALL_FULL_DATAROOTDIR}/aclocal")
+        WORKING_DIRECTORY \"${CMAKE_CURRENT_BINARY_DIR}\")")
+    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libSDL${SOPOSTFIX}${SOEXT} DESTINATION "${CMAKE_INSTALL_LIBDIR}")
+  endif()
+
+  install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/sdl.m4" DESTINATION "${CMAKE_INSTALL_FULL_DATAROOTDIR}/aclocal")
 endif()
 
 if(STATICDEVEL AND SDL12DEVEL)
   add_library(SDL-static STATIC ${SDL12COMPAT_SRCS})
   target_include_directories(SDL-static PRIVATE ${SDL2_INCLUDE_DIRS})
   set_target_properties(SDL-static PROPERTIES COMPILE_DEFINITIONS "_REENTRANT")
-  target_link_libraries(SDL-static PRIVATE ${CMAKE_DL_LIBS})
-  set_target_properties(SDL-static PROPERTIES
-          VERSION "${PROJECT_VERSION}"
-        OUTPUT_NAME "SDL")
-
-  install(TARGETS SDL-static
-    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-  )
-endif()

=== debian/changelog ===
sdl12-compat (1.2.69~git20250930~6152f8d-1) experimental; urgency=medium

  * New upstream snapshot, release-1.2.68-54-g6152f8d
  * d/p/sdl.m4-Call-PKG_CONFIG-rather-than-hard-coding-pkg-config.patch:
    Drop patch, applied upstream
  * d/copyright: Update
  * d/libsdl1.2debian.symbols: Update
  * d/control: Use debian/snapshots git branch
  * d/control, d/rules: Use cmake+ninja for build
  * d/control, d/rules: ${sdl12compat:Takeover-Version} doesn't need
    to vary. The transition from "classic" SDL 1.2 to sdl12-compat
    happened in Debian 13.
  * d/watch*: Convert to uscan format v5
  * d/upstream/signing-key.asc: Add.
    This is only a 1024-bit DSA key, but it's better than nothing.
  * Reformat packaging files with debputy
  * Standards-Version: 4.7.2 (no changes required)
  * Remove Rules-Requires-Root, not needed since Debian 13

 -- Simon McVittie <smcv@debian.org>  Tue, 30 Sep 2025 21:52:14 +0100

sdl12-compat (1.2.68-3) unstable; urgency=medium

  * d/control: Make the Maintainer consistent with other SDL packages

 -- Simon McVittie <smcv@debian.org>  Mon, 03 Mar 2025 19:34:58 +0000

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,22 @@
 Source: sdl12-compat
+X-Style: black
 Priority: optional
-Maintainer: Debian SDL package maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
+Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
 Uploaders:
  Simon McVittie <smcv@debian.org>,
  Stephen Kitt <skitt@debian.org>,
 Build-Depends:
+ debhelper-compat (= 13),
  cmake,
- debhelper-compat (= 13),
  libglu1-mesa-dev,
  libsdl2-dev,
  libx11-dev,
-Standards-Version: 4.6.2
+ ninja-build,
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/libsdl-org/sdl12-compat
-Vcs-Git: https://salsa.debian.org/sdl-team/sdl12-compat.git
+Vcs-Git: https://salsa.debian.org/sdl-team/sdl12-compat.git -b debian/snapshots
 Vcs-Browser: https://salsa.debian.org/sdl-team/sdl12-compat
-Rules-Requires-Root: no
 
 Package: libsdl1.2-compat
 Section: oldlibs
@@ -56,11 +57,11 @@
  libsdl-dev (= ${binary:Version}),
  libsdl1.2-compat-dev (= ${binary:Version}),
 Breaks:
- libsdl-dev (<< ${sdl12compat:Takeover-Version}~),
- libsdl1.2-compat-dev (<< ${sdl12compat:Takeover-Version}~),
+ libsdl-dev (<< 1.2.64-4+exp1~),
+ libsdl1.2-compat-dev (<< 1.2.64-4+exp1~),
 Replaces:
- libsdl-dev (<< ${sdl12compat:Takeover-Version}~),
- libsdl1.2-compat-dev (<< ${sdl12compat:Takeover-Version}~),
+ libsdl-dev (<< 1.2.64-4+exp1~),
+ libsdl1.2-compat-dev (<< 1.2.64-4+exp1~),
 Description: SDL 1.2 binary compatibility library - development files
  sdl12-compat provides a binary compatible API for programs built
  against SDL 1.2, but using SDL 2.0.
@@ -83,11 +84,11 @@
  libsdl-1.2-0 (= ${binary:Version}),
  libsdl1.2-compat-shim (= ${binary:Version}),
 Breaks:
- libsdl1.2-compat (<< ${sdl12compat:Takeover-Version}~),
- libsdl1.2-compat-shim (<< ${sdl12compat:Takeover-Version}~),
+ libsdl1.2-compat (<< 1.2.64-4+exp1~),
+ libsdl1.2-compat-shim (<< 1.2.64-4+exp1~),
 Replaces:
- libsdl1.2-compat (<< ${sdl12compat:Takeover-Version}~),
- libsdl1.2-compat-shim (<< ${sdl12compat:Takeover-Version}~),
+ libsdl1.2-compat (<< 1.2.64-4+exp1~),
+ libsdl1.2-compat-shim (<< 1.2.64-4+exp1~),
 Description: SDL 1.2 binary compatibility library wrapping SDL 2.0
  This package contains sdl12-compat, a binary compatible API for programs built
  against SDL 1.2, but using SDL 2.0.
@@ -123,8 +124,8 @@
 Architecture: any
 Multi-Arch: same
 Depends:
+ libsdl1.2-compat (>= ${binary:Version}),
  libsdl1.2debian (>= ${binary:Version}),
- libsdl1.2-compat (>= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: libsdl1.2debian replacement using SDL 2.0 - transitional package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

# used in dh_install, dh_link
export ABI_VERSION=1.2.69

%:
	dh $@ -Scmake+ninja

# There are no automated tests in this package
override_dh_auto_test:

# debhelper >= 13.4 makes all of /usr/libexec executable, which is not
# quite right for installed-tests (#1006927)
override_dh_fixperms:
	dh_fixperms -Xusr/libexec/installed-tests
	chmod --recursive a+rX,u+w,og-w debian/*-tests/usr/libexec/installed-tests

=== debian/watch ===
Version: 5

Source: https://github.com/libsdl-org/sdl12-compat.git
Matching-Pattern: HEAD
Compression: xz
Dversion-Mangle: s/[+~](?:ds|dfsg)[0-9]*$//;s/\+(?:git)?[0-9]+(?:\+g[0-9a-f]*)?$//
Mode: git
Pgp-Mode: none
Git-Pretty: 1.2.69~git%cd~%h
Repack: yes
Repacksuffix: +ds

## sdl12-compat 1.2.69~git20251026~20ab160

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,9 +3,7 @@
 #        cmake -DSDL2_INCLUDE_DIR=/opt/SDL2/include/SDL2 [other stuff]
 
 cmake_minimum_required(VERSION 3.0.0...4.0)
-project(sdl12_compat
-        VERSION 1.2.69
-        LANGUAGES C)
+project(sdl12_compat VERSION 1.2.69 LANGUAGES C)
 
 option(SDL12TESTS "Enable to build SDL-1.2 test programs" ON)
 option(SDL12DEVEL "Enable installing SDL-1.2 development headers" ON)
@@ -295,6 +293,13 @@
 
     configure_file("${CMAKE_CURRENT_SOURCE_DIR}/sdl-config.in" "${CMAKE_CURRENT_BINARY_DIR}/sdl-config" @ONLY)
     install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/sdl-config" DESTINATION bin)
+
+    # uninstall
+    if(NOT TARGET uninstall)
+      configure_file(cmake/cmake_uninstall.cmake.in "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)
+      add_custom_target(uninstall
+        COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
+    endif()
   endif()
 
   set(SOEXT ${CMAKE_SHARED_LIBRARY_SUFFIX})
@@ -307,10 +312,3 @@
     install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libSDL${SOPOSTFIX}${SOEXT} DESTINATION "${CMAKE_INSTALL_LIBDIR}")
   endif()
 
-  install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/sdl.m4" DESTINATION "${CMAKE_INSTALL_FULL_DATAROOTDIR}/aclocal")
-endif()
-
-if(STATICDEVEL AND SDL12DEVEL)
-  add_library(SDL-static STATIC ${SDL12COMPAT_SRCS})
-  target_include_directories(SDL-static PRIVATE ${SDL2_INCLUDE_DIRS})
-  set_target_properties(SDL-static PROPERTIES COMPILE_DEFINITIONS "_REENTRANT")

=== debian/changelog ===
sdl12-compat (1.2.69~git20251026~20ab160-1) experimental; urgency=medium

  [ Simon McVittie ]
  * New upstream snapshot, commit release-1.2.68-66-g20ab160
  * d/copyright: Update

  [ Antoine Le Gonidec ]
  * Add myself to Uploaders, I am going to need this through ./play.it
    for the foreseeable future.

 -- Simon McVittie <smcv@debian.org>  Mon, 27 Oct 2025 15:16:21 +0000
